var
  f: TextFile;
  S, k, a: Integer;
  b: Extended;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, S, k);
  CloseFile(f);
  AssignFile(f, 'output.txt'); Rewrite(f);
  for a := 1 to k do begin
    // 2S = (b + a)(b - a + 1) = b^2 - a^2 + b + a => b^2 + b + (-2S - a^2 + a)
    // b = -1 + Sqrt(1 + 8*S + 4a^2 - 4a) /2
    b := 1.0 + 8.0 * S + 4.0 * a * (a - 1.0);
    b := (Sqrt(b) - 1) / 2;
    if (b >= k) and (b = Trunc(b)) then begin
      Writeln(f, a, ' ', Trunc(b));
      CloseFile(f);
      Halt;
    end;
  end;
  Writeln(f, 0);
  CloseFile(f);
end.
